package com.company.composition.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;

import java.util.UUID;

@JmixEntity
@Table(name = "ALERT", indexes = {
        @Index(name = "IDX_ALERT_IT_SERVICE", columnList = "IT_SERVICE_ID")
})
@Entity
public class Alert {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;
    @NotNull
    @Column(name = "TYPE_", nullable = false)
    private Integer type;
    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "IT_SERVICE_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private ItService itService;

    public AlertType getType() {
        return type == null ? null : AlertType.fromId(type);
    }

    public void setType(AlertType type) {
        this.type = type == null ? null : type.getId();
    }

    public ItService getItService() {
        return itService;
    }

    public void setItService(ItService itService) {
        this.itService = itService;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}