package com.company.composition.entity;

import io.jmix.core.metamodel.datatype.EnumClass;

import org.springframework.lang.Nullable;


public enum AlertType implements EnumClass<Integer> {

    DEBUG(10),
    INFO(20),
    WARNING(30),
    ALARM(40);

    private final Integer id;

    AlertType(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    @Nullable
    public static AlertType fromId(Integer id) {
        for (AlertType at : AlertType.values()) {
            if (at.getId().equals(id)) {
                return at;
            }
        }
        return null;
    }
}