package com.company.composition.entity;

import io.jmix.core.metamodel.datatype.EnumClass;

import org.springframework.lang.Nullable;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


public enum MemorySize implements EnumClass<Integer> {

    GB32(10),
    GB64(20),
    GB128(30),
    GB256(40),
    GB512(50);

    private final Integer id;

    MemorySize(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    @Nullable
    public static MemorySize fromId(Integer id) {
        for (MemorySize at : MemorySize.values()) {
            if (at.getId().equals(id)) {
                return at;
            }
        }
        return null;
    }

    public static List<MemorySize> getPhysicalServerMemorySizes() {
        return (new ArrayList<>(Arrays.asList(MemorySize.GB32, MemorySize.GB64, MemorySize.GB128)));
    }

    public static List<MemorySize> getVirtualServerMemorySizes() {
        return (new ArrayList<>(Arrays.asList(MemorySize.GB128, MemorySize.GB256, MemorySize.GB512)));
    }
}