package com.company.composition.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;

import java.util.UUID;

@JmixEntity
@Table(name = "SERVER", indexes = {
        @Index(name = "IDX_SERVER_DATA_CENTER", columnList = "DATA_CENTER_ID")
})
@Entity
public class Server {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;
    @Column(name = "MEMORY_SIZE", nullable = false)
    @NotNull
    private Integer memorySize;
    @NotNull
    @InstanceName
    @Column(name = "NAME", nullable = false)
    private String name;
    @Column(name = "TYPE_", nullable = false)
    @NotNull
    private Integer type;
    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "DATA_CENTER_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private DataCenter dataCenter;

    public MemorySize getMemorySize() {
        return memorySize == null ? null : MemorySize.fromId(memorySize);
    }

    public void setMemorySize(MemorySize memorySize) {
        this.memorySize = memorySize == null ? null : memorySize.getId();
    }

    public DataCenter getDataCenter() {
        return dataCenter;
    }

    public void setDataCenter(DataCenter dataCenter) {
        this.dataCenter = dataCenter;
    }

    public ServerType getType() {
        return type == null ? null : ServerType.fromId(type);
    }

    public void setType(ServerType type) {
        this.type = type == null ? null : type.getId();
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}