package com.company.composition.entity;

import io.jmix.core.metamodel.datatype.EnumClass;

import org.springframework.lang.Nullable;


public enum ServerType implements EnumClass<Integer> {

    PHYSICAL(10),
    VIRTUAL(20);

    private final Integer id;

    ServerType(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    @Nullable
    public static ServerType fromId(Integer id) {
        for (ServerType at : ServerType.values()) {
            if (at.getId().equals(id)) {
                return at;
            }
        }
        return null;
    }
}