package com.company.composition.view.datacenter;

import com.company.composition.entity.DataCenter;
import com.company.composition.entity.Server;
import com.company.composition.entity.ServerType;
import com.company.composition.view.main.MainView;
import com.company.composition.view.server.ServerDetailView;
import com.vaadin.flow.router.Route;
import io.jmix.core.DataManager;
import io.jmix.flowui.DialogWindows;
import io.jmix.flowui.component.grid.DataGrid;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.model.CollectionPropertyContainer;
import io.jmix.flowui.model.DataContext;
import io.jmix.flowui.model.InstanceContainer;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "dataCenters/:id", layout = MainView.class)
@ViewController(id = "DataCenter.detail")
@ViewDescriptor(path = "data-center-detail-view.xml")
@EditedEntityContainer("dataCenterDc")
public class DataCenterDetailView extends StandardDetailView<DataCenter> {

    @ViewComponent
    private DataContext dataContext;
    @Autowired
    private DataManager dataManager;
    @ViewComponent
    private InstanceContainer<DataCenter> dataCenterDc;
    @ViewComponent
    private CollectionPropertyContainer<Server> serverDc;
    @Autowired
    private DialogWindows dialogWindows;
    @ViewComponent
    private DataGrid<Server> serverDataGrid;

    @Subscribe("serverDataGrid.create")
    public void onServerDataGridCreate(final ActionPerformedEvent event) {

        DialogWindow<ServerDetailView> dialogWindow = dialogWindows.detail(this, Server.class)
                .withViewClass(ServerDetailView.class)
                .newEntity()
                .build();   // The new view’s onInit() is called here.

        dialogWindow.getView().setDataCenterName(dataCenterDc.getItem().getName());
        dialogWindow.getView().setServerMemorySizeOptions(null);    // null for a new entity
        dialogWindow.open();
    }
}