package com.company.composition.view.server;

import com.company.composition.entity.MemorySize;
import com.company.composition.entity.Server;
import com.company.composition.entity.ServerType;
import com.company.composition.view.main.MainView;
import com.vaadin.flow.component.AbstractField;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.component.select.JmixSelect;
import io.jmix.flowui.component.textfield.TypedTextField;
import io.jmix.flowui.view.*;

@Route(value = "servers/:id", layout = MainView.class)
@ViewController(id = "Server.detail")
@ViewDescriptor(path = "server-detail-view.xml")
@EditedEntityContainer("serverDc")
public class ServerDetailView extends StandardDetailView<Server> {
    
    @ViewComponent
    private TypedTextField<String> dataCenterNameField;
    @ViewComponent
    private JmixSelect<MemorySize> memorySizeSelectld;

    public void setDataCenterName(String dataCenterName) {

        dataCenterNameField.setValue(dataCenterName);
    }

    public void setServerMemorySizeOptions(ServerType serverType) {

        if (serverType == null) {
            return;
        }

        if (serverType.equals(ServerType.PHYSICAL)) {
            memorySizeSelectld.setItems(MemorySize.getPhysicalServerMemorySizes());
        } else {
            memorySizeSelectld.setItems(MemorySize.getVirtualServerMemorySizes());
        }
    }

    @Subscribe
    public void onInit(final InitEvent event) {

        memorySizeSelectld.setEnabled(false);
    }

    @Subscribe("typeField")
    public void onTypeFieldComponentValueChange(final AbstractField.ComponentValueChangeEvent<JmixSelect<ServerType>, ServerType> event) {

        setServerMemorySizeOptions(event.getValue());
        memorySizeSelectld.setEnabled(true);
    }
}